"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _nodeFetch = _interopRequireDefault(require("node-fetch"));

var _moduleReplication = require("@resolve-js/module-replication");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const callReplicate = async (pool, lockId, events, secretsToSet, secretsToDelete, iterator) => {
  var _result$message, _result$state;

  const data = {
    lockId,
    events,
    secretsToSet,
    secretsToDelete,
    iterator
  };
  const response = await (0, _nodeFetch.default)(`${pool.targetApplicationUrl}${_moduleReplication.REPLICATE.endpoint}`, {
    method: _moduleReplication.REPLICATE.method,
    body: JSON.stringify(data),
    headers: {
      'Content-Type': 'application/json'
    }
  });
  let resultType = 'unknown';
  const result = await response.json();

  if (response.status >= 500) {
    resultType = 'serverError';
  } else if (response.status >= 400) {
    resultType = 'clientError';
  } else if (response.status === 202) {
    resultType = 'launched';
  } else if (response.status === 200) {
    resultType = 'processed';
  }

  return {
    type: resultType,
    httpStatus: response.status,
    message: (_result$message = result.message) !== null && _result$message !== void 0 ? _result$message : result,
    state: (_result$state = result.state) !== null && _result$state !== void 0 ? _result$state : null
  };
};

var _default = callReplicate;
exports.default = _default;
//# sourceMappingURL=call-replicate.js.map